/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.invoke.*;

public class MyCL extends ClassLoader {
 public static void test() {
  try {
   MethodHandles.Lookup l=MethodHandles.lookup();
   System.out.println("lookup: "+l.lookupClass()+"/"+l.lookupModes());

   Class ctab[]=new Class[5];
   ctab[0]=java.lang.String.class;
   ctab[1]=(new byte[0]).getClass();
   ctab[2]=Integer.TYPE;
   ctab[3]=Integer.TYPE;
   ctab[4]=java.security.ProtectionDomain.class;

   MethodType desc=MethodType.methodType(java.lang.Class.class,ctab);

   MethodHandle mh=l.findVirtual(java.lang.ClassLoader.class,"defineClass",desc);
   System.out.println(mh);
  } catch(Throwable t) {
   t.printStackTrace();
  }
 }
}
